var Add = {
	init: function(a) {
		
		if (a) {
			$(".add-rules").removeClass("hide");
		}
		
		Add.brewery_countries();
		Add.brewery_types();
		Add.beer_types("beer_types");
		
		
	},
	brewery_countries: function() {
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{		
			if ($("#brewery_country option").length == 1) {
				ajaxStatement = $.ajax({
					url: host + "/helpers/list_brewery_countries?access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(html)
					{
						if (html.meta.code == 200)
						{
							/*var source   = $("#country-template").html();
							var template = Handlebars.compile(source);*/
							
							var template = Handlebars.templates['country-template.tmpl'];
							var info = template(html.response);
					
							$("#brewery_country").html(info);
						}
					}
				});
			}
		}
	},
	brewery_name_add: function() {
		$("#brewery_form_name").val($("#breweryadd-search-term").val());
	},
	beer_name_add: function() {
		$("#beer_form_name").val($("#beeradd-search-term").val());
	},
	brewery_types: function() {
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			if ($("#brewery_type option").length == 1) {
				ajaxStatement = $.ajax({
					url: host + "/helpers/list_brewery_types?access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(html)
					{
						if (html.meta.code == 200)
						{
							/*var source   = $("#brewery-type-template").html();
							var template = Handlebars.compile(source);*/
							
							var template = Handlebars.templates['brewery-type-template.tmpl'];
							var info = template(html.response);

							$("#brewery_type").html(info);
						}
					}
				});
			}
		}
	},
	beer_types: function(a,b) {
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			if ($("#beer_types option").length == 1) {
				ajaxStatement = $.ajax({
					url: host + "/helpers/list_beer_types?access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(html)
					{
						if (html.meta.code == 200)
						{
							/*var source   = $("#beer-type-template").html();
							var template = Handlebars.compile(source);*/
							
							var template = Handlebars.templates['beer-type-template.tmpl'];
							var info = template(html.response);

							$("#"+a).html(info);
							
							if (b) {
								$("#"+a + " option").each(function(){
									if ($(this).text() == b) {
										var q = $(this).val();
										$("#"+a).val(q);
										
										return false;
									}
								})
							}
							
						}
					}
				});
			}
		}	
	},
	brewery_add: function() {
		
		clearAjax();

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			Loading.on();
			
			var data = $("#add-brewery-form").serialize();
			
			ajaxStatement = $.ajax({
				url: host + "/brewery/add?access_token="+token,
				type: "POST",
				data: data,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Loading.off();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(html)
				{
					
					if (html.meta.code == 200)
					{
						Add.step(1, html.response.brewery.brewery_id, html.response.brewery.brewery_name)
						//Page.change("#!/beerArea/"+html.response.beer.bid+"/null/beerfinal", "show");	
						//location.href = "#!/addBeerArea4";
						Page.change("#!/addBeerArea4", "push");
						Loading.off();
					}
					else 
					{
						Loading.off();
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	beer_add: function() {
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			Loading.on();
			
			var data = $("#add-beer-form").serialize();
			
			ajaxStatement = $.ajax({
				url: host + "/beer/add?access_token="+token,
				type: "POST",
				data: data,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Loading.off();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(html)
				{
					Loading.off();
					
					if (html.meta.code == 200)
					{
						$("#beerfinal").html(JSON.stringify(html.response));
						//Page.change("#!/beerArea", "show");
						//Feed.beer(html.response.beer.bid, null, 'beerfinal');
						Page.change("#!/beerArea/"+html.response.beer.bid+"/null/beerfinal", "push");
					}
					else 
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	brewery_search: function(a) {
				
		$(".add-rules").addClass("hide");
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#addBeerArea1ContentArea").show();
			
			var d = $(a).serialize();
			
			ajaxStatement = $.ajax({
				url: host + "/search/brewery?access_token="+token,
				type: "GET",
				data: d,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						Template.add_brewery_search("addBeerArea1ContentArea", data.response);
						Add.init();	
						Add.brewery_name_add();
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}

		return false;
	},
	beer_search: function(a) {
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#addBeerArea3ContentArea").show();
			
			var d = $(a).serialize();
			
			ajaxStatement = $.ajax({
				url: host + "/search/beer?access_token="+token,
				type: "GET",
				data: d,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						Template.add_beer_search("addBeerArea3ContentArea", data.response);	
						Add.beer_name_add();
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}

		return false;
	},
	step: function(a, b, c) {
		if (a == "1") {
			$("#brewery_id_form").val(b);
			$("#brewery_id_search").val(b);
			$("#brewery_name_beer_add").html(c);
			$("#beeradd-brewery-id").val(b);
			$(".brewery-name-results").html(c);
		}
		else {
			$("#bid_form").val(b)
		}
	}
};