var memcache = {
	set: function(a,b, ttl) {
		if (ttl) {
			var ts = Math.round((new Date()).getTime() / 1000);
			var index = a+"_time";
			var pT = parseInt(ts) + parseInt(ttl);
			localStorage.setItem(index, pT);
		}
		localStorage.setItem(a, b);
	},
	clear: function() {
		localStorage.clear();
	},
	remove: function(a) {
		localStorage.removeItem(a);
	},
	get: function(a) {
		memcache.clean(a);
		return localStorage.getItem(a);
	},
	clean: function(a) {
		if (localStorage.getItem(a+"_time")) {
			var ts = Math.round((new Date()).getTime() / 1000);
			var expiresTime =localStorage.getItem(a+"_time");
			if (parseFloat(ts) > parseFloat(expiresTime)) {
				localStorage.removeItem(a);
			}
		}
		else {
			return true;
		}
	}
}